# FabLock for Ants Make AM-022
Custom firmware (written in C) for [Ants Make 16 Channel ESP32 Relay Driver 5V DC Module (AM-022)](https://templates.blakadder.com/ants-make_AM-022.html) 

Note: this module is also compatible with Tasmota firmware, but as statet, we use a our custom software.

# Supports up to 5 locker slots!

We can use one AM-022 for up to five locker slots. One locker requires 2 channels for the locker module (e.g. SARY XG07C) and 1 for the status LED (visualize the slot which is going to be opened). 

1 of the 16 channels will be left over. 

To build up a large-scale Ikea Kallax shelf with 20 slots you will need to repeat this 4 times!

# Installation
This part is not well documented yet. Please contribute!

The project is made with CMake. You will need a build [toolchain](https://docs.espressif.com/projects/esp-idf/en/v3.3/get-started-cmake/index.html) to deploy it on the ESP32 properly.

# Connections for 16-Relais Board
```
1 NC    GND_LED_1
1 COM   GND
1 NO    GND_LOCK_1

2 NC    GND_LED_2
2 COM   GND
2 NO    GND_LOCK_2

3 NC    GND_LED_3
3 COM   GND
3 NO    GND_LOCK_3

4 NC    GND_LED_4
4 COM   GND
4 NO    GND_LOCK_4

5 NC    GND_LED_5
5 COM   GND
5 NO    GND_LOCK_5

6 NC    
6 COM   
6 NO    

7 NC    
7 COM   12V
7 NO    LED_1

8 NC    
8 COM   12V
8 NO    LED_2

9 NC    
9 COM   12V
9 NO    LED_3

10 NC   
10 COM  12V
10 NO   LED_4

11 NC   
11 COM  12V
11 NO   LED_5

12 NC   
12 COM  12V
12 NO   LOCK_1

13 NC   
13 COM  12V
13 NO   LOCK_2

14 NC   
14 COM  12V
14 NO   LOCK_3

15 NC   
15 COM  12V
15 NO   LOCK_4

16 NC   
16 COM  12V
16 NO   LOCK_5
```